//============================================================================
//	epf130ep.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.01 Date 2000/4/25
//
//	tab stops is 2
//============================================================================
module epf130ep(
	Init_Done,
	nWs,
	nRs,
	nCs,
	Cs,
	RdynBsy,
	ClkUsr,
	Data,
	DedicatedInputPins,
	DedicatedClockPins,
	Dev_Oe,
	nDev_Clr,
	Useri,
	nDack0,
	nDreq0,
	nBtermo,
	Usero,
	nNb,
	nLserr,
	Breqo,
	nS0,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	Epm,
	Mem1,Mem2,Mem3,Mem4,Mem5,Mem6,Mem7,Mem8,Mem9,Mem10,
	Mem11,Mem12,Mem13,Mem14,Mem15,Mem16,Mem17,Mem18,Mem19,Mem20,
	Mem21,Mem22,Mem23,Mem24,Mem25,Mem26,Mem27,Mem28,Mem29,Mem30,
	Mem31,Mem32,Mem33,Mem34,Mem35,Mem36,Mem37,Mem38,Mem39,
	Cn1x,
	Cn4or5_e,
	Cn1_,
	Ld,
	La,
//Ioa,
//Iob,
	Ioc,
	Iod1_,
	Iod2_
);
//============================================================================
// PLX 
//============================================================================
output nLholda;		// Hold Acknowledge (output)
output nLlock;		// Bus Lock (output)
output nLinti;		// Local Interrupt In (output)
output nLreseti;	// Local Reset Input (output)
output nReadyi;		// Ready In (output)
output nBterm;		// Burst Terminate (output)
output nDreq0;		// DMA Request Input (output)
output nS0;				// Address Select 0 (output)
output nNb;				// No Local Bus Initialzation (output)
output nWaiti;		// Wait Input (output)
output nBreq;			// Bus Request (output)
output nEot0;			// End of Transfer (output)
output Useri;			// User Input (output)

input	 nBlast;		// Burst Last (I/O)
input	 nAds;			// Address Strobe (I/O)
output nWaito;		// Wait Out (input)
output nReadyo;		// Ready Out (input)
output nDen;			// Data Enable (input)
output nDt_r;			// Data Transmit/Receive (input)
input	 nLw_r;			// Write/Read (I/O)
input  nDack0;		// DMA Acknowledge Output (input)
output nBtermo;		// Burst Terminate Output (input)
output nLserr;		// System Error Interrupt Output (input)
output Breqo;			// Bus Request Out (input)
input	 nLreseto;	// Local Bus Reset Out (input)
output nDmapaf;		// Direct Master Programmable Almost Full (input)
output nLlocko;		// Bus Lock (input)
output Ldshold;		// Direct Slave HOLD Request (input)
input	 Lhold;			// Hold Request (input)
output Usero;			// User Output (input)

inout [31:0] Ld;	// DataBus31~0 (I/O)
input [16:2] La;	// AddressBus16~2 (I/O)
input	[3:0] nLbe;	// Byte Enables (I/O)
//============================================================================
// EPF10K Configuring
//============================================================================
inout Init_Done;	// User Mode I/O
inout nWs;				// User Mode I/O
inout nRs;				// User Mode I/O
inout nCs;				// User Mode I/O
inout Cs;					// User Mode I/O
inout RdynBsy;		// User Mode I/O
inout ClkUsr;			// User Mode I/O
inout Dev_Oe;			// User Mode I/O
inout nDev_Clr;		// User Mode I/O
inout [7:1] Data;	// User Mode I/O

input [3:0] DedicatedInputPins;
input [1:0] DedicatedClockPins;
//============================================================================
//	16Bit Mode
//	BE3	-> BHE(LD15:8)
//	BE0 -> BLE(LD7:0)
//	BE2 -> NOT USED
//	BE1 -> LA1
//							CY7C1020	STK22C48	PinName				CY7C1020		STK22C48
//============================================================================
output Mem1;	// ---			A0				MemAddr[0]								nLbe1(La1)
output Mem2;	// A0				A1				MemAddr[1]		nLbe1(La1)	La2
output Mem3;	// A1				A2				MemAddr[2]		La2					La3
output Mem4;	// A2				A3				MemAddr[3]		La3					La4
output Mem5;	// A3				A4				MemAddr[4]		La4					La5
output Mem6;	// A4				A5				MemAddr[5]		La5					La6
output Mem7;	// A5				A6				MemAddr[6]		La6					La7
output Mem8;	// A6				A7				MemAddr[7]		La7					La8
output Mem9;	// A7				A8				MemAddr[8]		La8					La9
output Mem10;	// A8				A9				MemAddr[9]		La9					La10
output Mem11;	// A9				A10				MemAddr[10]		La10				La11
output Mem12;	// A10			---				MemAddr[11]		La11
output Mem13;	// A11			---				MemAddr[12]		La12
output Mem14;	// A12			---				MemAddr[13]		La13
output Mem15;	// A13			---				MemAddr[14]		La14
output Mem16;	// A14			---				MemAddr[15]		La15
inout  Mem17;	// I/O1			DQ0				MemData[0]
inout  Mem18;	// I/O2			DQ1				MemData[1]
inout  Mem19;	// I/O3			DQ2				MemData[2]
inout  Mem20;	// I/O4			DQ3				MemData[3]
inout  Mem21;	// I/O5			DQ4				MemData[4]
inout  Mem22;	// I/O6			DQ5				MemData[5]
inout  Mem23;	// I/O7			DQ6				MemData[6]
inout  Mem24;	// I/O8			DQ7				MemData[7]
inout  Mem25;	// I/O9			---				MemData[8]
inout  Mem26;	// I/O10		---				MemData[9]
inout  Mem27;	// I/O11		---				MemData[10]
inout  Mem28;	// I/O12		---				MemData[11]
inout  Mem29;	// I/O13		---				MemData[12]
inout  Mem30;	// I/O14		---				MemData[13]
inout  Mem31;	// I/O15		---				MemData[14]
inout  Mem32;	// I/O16		---				MemData[15]
output Mem33;	// CE				---				nCy7Cs
output Mem34;	// ---			E					nStkCs
output Mem35;	// OE				G					nMemOe
output Mem36;	// WE				W					nMemWe
output Mem37;	// BLE			---				nBle					nBe0
output Mem38;	// BHE			---				nBhe					nBe3
output Mem39;	// ---			HSB				nHsb
//============================================================================
//					250E/200E 130E(672P) 130E/100A(484P) 100E  50E		Used Pin
//	Gloup A		O					X						X							X			X			57(IOA1~57)
//	Gloup B		O					O						X							X			X			44(IOB1~44)
//	Gloup C		O					O						O							X			X			31(IOC1~31)
//	Gloup D		O					O						O							O			X			84(IOD1~84)
//	Gloup E 	O					O						O							O			O			232
//============================================================================
output [45:1] Cn1_;			// IOE1~45 (Gloup E)
input  [45:1] Cn1x;			// IOE91~98,IOD16~52 (Gloup D/E)
output [45:1] Cn4or5_e;	// IOE46~90 (Gloup E)
//output [57:1]	Ioa;			// IOA1~57 (Gloup A)
//output [44:1]	Iob;			// IOB1~44 (Gloup B)
output [31:1] Ioc;			// IOC1~31 (Gloup C)
output [15:1] Iod1_;		// IOD1~15 (Gloup D)
output [84:53] Iod2_;		// IOD53~84 (Gloup D)
inout  [14:1] Epm;
//============================================================================
//
//============================================================================
reg [45:1]  rCn1_;
reg [45:1]  rCn4or5_e;
//reg [57:1]	rIoa;
//reg [44:1]	rIob;
reg [31:1]  rIoc;
reg [15:1]  rIod1_;
reg [84:53] rIod2_;
reg [16:1]	rEpf10kConf;
reg [14:9]	rEpm;
reg [31:0]	rIntReg;
reg nDreq0;
reg nLinti;
reg Useri;
//============================================================================
// Not Used Pin
//============================================================================
wire Dummy = 0;
assign nWaito =  (!Dummy) ? 1'bz : 0;
assign nReadyo = (!Dummy) ? 1'bz : 0;
assign nDen = 	 (!Dummy) ? 1'bz : 0;
assign nDt_r = 	 (!Dummy) ? 1'bz : 0;
assign nBtermo = (!Dummy) ? 1'bz : 0;
assign nLserr =  (!Dummy) ? 1'bz : 0;
assign Breqo = 	 (!Dummy) ? 1'bz : 0;
assign nDmapaf = (!Dummy) ? 1'bz : 0;
assign nLlocko = (!Dummy) ? 1'bz : 0;
assign Ldshold = (!Dummy) ? 1'bz : 0;
assign Usero = 	 (!Dummy) ? 1'bz : nLbe[2]; // Dummy
//============================================================================
// assign EPF10K
//============================================================================
wire [16:1] Epf10kConf = {nWs,nRs,RdynBsy,nCs,Cs,ClkUsr,Data[7:1],Init_Done,Dev_Oe,nDev_Clr};
wire [6:1] Dedi = {DedicatedInputPins,DedicatedClockPins};
//============================================================================
// assign
//============================================================================
wire Clk = DedicatedClockPins[0];
assign nLlock = 1;
assign nLreseti = 1;
assign nBterm = 1;
assign nS0 = 1;
assign nNb = 0;
assign nWaiti = 1;
assign nBreq = 1;
assign nEot0 = 1;
//============================================================================
// declare Direct Slave Single Cycle
//============================================================================
reg [4:0] s;
reg nLholda;
reg nReadyi;
reg [15:0] rOe;
reg nMemOe,nMemWe;
parameter s0 = 5'b00001;
parameter s1 = 5'b00010;
parameter s2 = 5'b00100;
parameter s3 = 5'b01000;
parameter s4 = 5'b10000;
//============================================================================
always @(posedge Clk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
		s <= s0;
		nReadyi <= 1;
		nLholda <= 1;
	end else begin
		nLholda <= ~Lhold;
		case (s)
		s0: begin nReadyi <= 1; if (!nAds)	 s <= s1;
														else				 s <= s0;	end
		s1:	begin														 s <= s2; end
		s2:	begin	nReadyi <= 0;							 s <= s3; end
		s3:	begin nReadyi <= 1; if (!nBlast) s <= s0;
														else 				 s <= s4;	end
		s4: begin														 s <= s1;	end
		endcase
	end
end
//============================================================================
// declare Memory Gloup
// 16bit Bus
//============================================================================
reg	 [15:0] MemAddr;
wire [15:0] MemData;
reg	 nStkCs,nCy7Cs;
reg	 nHsb;
reg	 nBhe,nBle;

wire Equ00000_00FFF = (La[16:12]==5'h0);	// 2kb * 2 = 4kb
wire Equ10000_1FFFF = (La[16]);						// 32*16bit = 64kb

wire EquMid10 = (La[16:8]==9'h010);
wire EquLo_00 = ({La[7:2],nLbe[1],nLbe[0]}==8'h00); // nLbe1=LA1 nLbe0=LA0 (8bitBus)
wire EquLo_01 = ({La[7:2],nLbe[1],nLbe[0]}==8'h01);
wire EquLo_02 = ({La[7:2],nLbe[1],nLbe[0]}==8'h02);
wire EquLo_03 = ({La[7:2],nLbe[1],nLbe[0]}==8'h03);
wire EquLo_04 = ({La[7:2],nLbe[1],nLbe[0]}==8'h04);
wire EquLo_05 = ({La[7:2],nLbe[1],nLbe[0]}==8'h05);
wire EquLo_06 = ({La[7:2],nLbe[1],nLbe[0]}==8'h06);
wire EquLo_07 = ({La[7:2],nLbe[1],nLbe[0]}==8'h07);
wire EquLo_08 = ({La[7:2],nLbe[1],nLbe[0]}==8'h08);
wire EquLo_09 = ({La[7:2],nLbe[1],nLbe[0]}==8'h09);
wire EquLo_0a = ({La[7:2],nLbe[1],nLbe[0]}==8'h0a);
wire EquLo_0b = ({La[7:2],nLbe[1],nLbe[0]}==8'h0b);
wire EquLo_0c = ({La[7:2],nLbe[1],nLbe[0]}==8'h0c);
wire EquLo_0d = ({La[7:2],nLbe[1],nLbe[0]}==8'h0d);
wire EquLo_0e = ({La[7:2],nLbe[1],nLbe[0]}==8'h0e);
wire EquLo_0f = ({La[7:2],nLbe[1],nLbe[0]}==8'h0f);
wire EquLo_10 = ({La[7:2],nLbe[1],nLbe[0]}==8'h10);
wire EquLo_11 = ({La[7:2],nLbe[1],nLbe[0]}==8'h11);
wire EquLo_12 = ({La[7:2],nLbe[1],nLbe[0]}==8'h12);
wire EquLo_13 = ({La[7:2],nLbe[1],nLbe[0]}==8'h13);
wire EquLo_14 = ({La[7:2],nLbe[1],nLbe[0]}==8'h14);
wire EquLo_15 = ({La[7:2],nLbe[1],nLbe[0]}==8'h15);
wire EquLo_16 = ({La[7:2],nLbe[1],nLbe[0]}==8'h16);
wire EquLo_17 = ({La[7:2],nLbe[1],nLbe[0]}==8'h17);
wire EquLo_18 = ({La[7:2],nLbe[1],nLbe[0]}==8'h18);
wire EquLo_19 = ({La[7:2],nLbe[1],nLbe[0]}==8'h19);
wire EquLo_1a = ({La[7:2],nLbe[1],nLbe[0]}==8'h1a);
wire EquLo_1b = ({La[7:2],nLbe[1],nLbe[0]}==8'h1b);
wire EquLo_1c = ({La[7:2],nLbe[1],nLbe[0]}==8'h1c);
wire EquLo_1d = ({La[7:2],nLbe[1],nLbe[0]}==8'h1d);
wire EquLo_1e = ({La[7:2],nLbe[1],nLbe[0]}==8'h1e);
wire EquLo_1f = ({La[7:2],nLbe[1],nLbe[0]}==8'h1f);
wire EquLo_20 = ({La[7:2],nLbe[1],nLbe[0]}==8'h20);
wire EquLo_21 = ({La[7:2],nLbe[1],nLbe[0]}==8'h21);
wire EquLo_22 = ({La[7:2],nLbe[1],nLbe[0]}==8'h22);
wire EquLo_23 = ({La[7:2],nLbe[1],nLbe[0]}==8'h23);
wire EquLo_24 = ({La[7:2],nLbe[1],nLbe[0]}==8'h24);
wire EquLo_25 = ({La[7:2],nLbe[1],nLbe[0]}==8'h25);
wire EquLo_26 = ({La[7:2],nLbe[1],nLbe[0]}==8'h26);
wire EquLo_27 = ({La[7:2],nLbe[1],nLbe[0]}==8'h27);
wire EquLo_28 = ({La[7:2],nLbe[1],nLbe[0]}==8'h28);
wire EquLo_29 = ({La[7:2],nLbe[1],nLbe[0]}==8'h29);
wire EquLo_2a = ({La[7:2],nLbe[1],nLbe[0]}==8'h2a);
wire EquLo_2b = ({La[7:2],nLbe[1],nLbe[0]}==8'h2b);
wire EquLo_2c = ({La[7:2],nLbe[1],nLbe[0]}==8'h2c);
wire EquLo_2d = ({La[7:2],nLbe[1],nLbe[0]}==8'h2d);
wire EquLo_2e = ({La[7:2],nLbe[1],nLbe[0]}==8'h2e);
wire EquLo_2f = ({La[7:2],nLbe[1],nLbe[0]}==8'h2f);
wire EquLo_30 = ({La[7:2],nLbe[1],nLbe[0]}==8'h30);
wire EquLo_31 = ({La[7:2],nLbe[1],nLbe[0]}==8'h31);
wire EquLo_32 = ({La[7:2],nLbe[1],nLbe[0]}==8'h32);
wire EquLo_33 = ({La[7:2],nLbe[1],nLbe[0]}==8'h33);
wire EquLo_34 = ({La[7:2],nLbe[1],nLbe[0]}==8'h34);
wire EquLo_35 = ({La[7:2],nLbe[1],nLbe[0]}==8'h35);
wire EquLo_36 = ({La[7:2],nLbe[1],nLbe[0]}==8'h36);
wire EquLo_37 = ({La[7:2],nLbe[1],nLbe[0]}==8'h37);
wire EquLo_38 = ({La[7:2],nLbe[1],nLbe[0]}==8'h38);
wire EquLo_34DW = ({La[7:2]}==(8'h34>>2));
//============================================================================
always @(posedge Clk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
		nMemWe <= 1;
		nMemOe <= 1;
	end else begin
		if ((s==s1) || (s==s2)) begin
			if (nLw_r) nMemWe <= 0;	// Write
			else 			 nMemOe <= 0;	// Read
		end else begin
			nMemWe <= 1;
			nMemOe <= 1;
		end
	end
end
//============================================================================
always @(posedge Clk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
		MemAddr <= 0;
		nStkCs <= 1;
		nCy7Cs <= 1;
		nBhe <= 1;
		nBle <= 1;
	end else begin
		nBhe <= nLbe[3];
		nBle <= nLbe[0];
		if (Equ00000_00FFF && (!nLbe[0])) begin
			nStkCs <= 0;
			nCy7Cs <= 1;
			MemAddr <= {1'b0,La[15:2],nLbe[1]};
		end	else if (Equ10000_1FFFF) begin
			nStkCs <= 1;
			nCy7Cs <= 0;
			MemAddr <= {La[15:2],nLbe[1],1'b0};
		end else begin
			nStkCs <= 1;
			nCy7Cs <= 1;
			MemAddr <= {La[15:2],nLbe[1],1'b0};
		end
	end
end
//============================================================================
// assign
//============================================================================
assign Mem1  = MemAddr[0];
assign Mem2  = MemAddr[1];
assign Mem3  = MemAddr[2];
assign Mem4  = MemAddr[3];
assign Mem5  = MemAddr[4];
assign Mem6  = MemAddr[5];
assign Mem7  = MemAddr[6];
assign Mem8  = MemAddr[7];
assign Mem9  = MemAddr[8];
assign Mem10 = MemAddr[9];
assign Mem11 = MemAddr[10];
assign Mem12 = MemAddr[11];
assign Mem13 = MemAddr[12];
assign Mem14 = MemAddr[13];
assign Mem15 = MemAddr[14];
assign Mem16 = MemAddr[15];

assign Mem17 = MemData[0];
assign Mem18 = MemData[1];
assign Mem19 = MemData[2];
assign Mem20 = MemData[3];
assign Mem21 = MemData[4];
assign Mem22 = MemData[5];
assign Mem23 = MemData[6];
assign Mem24 = MemData[7];
assign Mem25 = MemData[8];
assign Mem26 = MemData[9];
assign Mem27 = MemData[10];
assign Mem28 = MemData[11];
assign Mem29 = MemData[12];
assign Mem30 = MemData[13];
assign Mem31 = MemData[14];
assign Mem32 = MemData[15];

assign Mem33 = nCy7Cs;
assign Mem34 = nStkCs;
assign Mem35 = nMemOe;
assign Mem36 = nMemWe;
assign Mem37 = nLbe[0];
assign Mem38 = nLbe[3];
assign Mem39 = (!nHsb) ? 0 : 1'bz;
//============================================================================
always @(posedge Clk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
//	rIoa <= 0;
//	rIob <= 0;
		rIoc <= 0;
		rIod1_ <= 0;
		rIod2_ <= 0;
		rCn1_ <= 0;
		rCn4or5_e <= 0;
		Useri <= 0;
		nHsb <= 1;
		rOe <= 0;
		rEpf10kConf <= 0;
		rEpm <= 0;
		rIntReg <= 0;
		nDreq0 <= 1;
		nLinti <= 1;
	end else begin
		if ((s==s3) && (nLw_r)) begin
/*
			if (EquMid10 && EquLo_00) rIoa[8:1]				<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_01) rIoa[16:9]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_02) rIoa[24:17]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_03) rIoa[32:25]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_04) rIoa[40:33]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_05) rIoa[48:41]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_06) rIoa[56:49]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_07) rIoa[57]				<= Ld[0];   // 8bit Bus Width
			if (EquMid10 && EquLo_08) rIob[8:1]				<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_09) rIob[16:9]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_0a) rIob[24:17]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_0b) rIob[32:25]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_0c) rIob[40:33]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_0d) rIob[44:41]			<= Ld[3:0]; // 8bit Bus Width
*/
			if (EquMid10 && EquLo_0e) rIoc[8:1]				<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_0f) rIoc[16:9]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_10) rIoc[24:17]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_11) rIoc[31:25]			<= Ld[6:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_12) rIod1_[8:1]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_13) rIod1_[15:9]		<= Ld[6:0]; // 8bit Bus Width
			// 14`19 Cn1x Read Only
			if (EquMid10 && EquLo_1a) rIod2_[60:53]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_1b) rIod2_[68:61]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_1c) rIod2_[76:69]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_1d) rIod2_[84:77]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_1e) rCn1_[8:1]				<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_1f) rCn1_[16:9]				<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_20) rCn1_[24:17]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_21) rCn1_[32:25]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_22) rCn1_[40:33]			<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_23) rCn1_[45:41]			<= Ld[4:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_24) rCn4or5_e[8:1]		<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_25) rCn4or5_e[16:9]		<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_26) rCn4or5_e[24:17]	<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_27) rCn4or5_e[32:25]	<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_28) rCn4or5_e[40:33]	<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_29) rCn4or5_e[45:41]	<= Ld[4:0]; // 8bit Bus Width
			// 2a Epm[8:1] is Read Only
			if (EquMid10 && EquLo_2b) rEpm[14:9]				<= Ld[5:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_2c) rEpf10kConf[8:1]	<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_2d) rEpf10kConf[16:9]	<= Ld[7:0]; // 8bit Bus Width
			// 2e Dedi Read Only
			if (EquMid10 && EquLo_30) {Useri,nHsb}			<= Ld[1:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_31) rOe[7:0]					<= Ld[7:0]; // 8bit Bus Width
			if (EquMid10 && EquLo_32) rOe[15:8]					<= Ld[7:0]; // 8bit Bus Width

			if (EquMid10 && EquLo_34DW && (!nLbe[0])) rIntReg[7:0]		<= Ld[7:0];		// 32bit Bus Width
			if (EquMid10 && EquLo_34DW && (!nLbe[1])) rIntReg[15:8]		<= Ld[15:8];	// 32bit Bus Width
			if (EquMid10 && EquLo_34DW && (!nLbe[2])) rIntReg[23:16]	<= Ld[23:16];	// 32bit Bus Width
			if (EquMid10 && EquLo_34DW && (!nLbe[3])) rIntReg[31:24]	<= Ld[31:24];	// 32bit Bus Width
			if (EquMid10 && EquLo_38) {nDreq0,nLinti}   <= Ld[1:0]; // 8bit Bus Width
		end else begin
			if (!nDack0) nDreq0 <= 1'b1;
		end
	end
end
//============================================================================
// assign
//============================================================================
assign MemData = (!nMemWe) ? Ld[15:0] : 16'hz;
//============================================================================
function [15:0] ReadData;
//============================================================================
input nMemOe;
input [15:0] MemData;
input [45:1] Cn1x;
input [8:1] Epm;
input [16:1] Epf10kConf;
input [6:1] Dedi;
input [31:0] rIntReg;
input nDreq0;
input nLinti;
input Equ00000_00FFF;
input Equ10000_1FFFF;
input EquMid10;
input EquLo_14;
input EquLo_15;
input EquLo_16;
input EquLo_17;
input EquLo_18;
input EquLo_19;
input EquLo_2a;
input EquLo_2c;
input EquLo_2d;
input EquLo_2e;
input EquLo_34;
input EquLo_35;
input EquLo_36;
input EquLo_37;
input EquLo_38;

begin
	if (!nMemOe) begin
		if (Equ00000_00FFF || Equ10000_1FFFF)	ReadData = MemData;
		else if (EquMid10 && EquLo_14) ReadData = {8'h00,Cn1x[8:1]};
		else if (EquMid10 && EquLo_15) ReadData = {8'h00,Cn1x[16:9]};
		else if (EquMid10 && EquLo_16) ReadData = {8'h00,Cn1x[24:17]};
		else if (EquMid10 && EquLo_17) ReadData = {8'h00,Cn1x[32:25]};
		else if (EquMid10 && EquLo_18) ReadData = {8'h00,Cn1x[40:33]};
		else if (EquMid10 && EquLo_19) ReadData = {11'h0,Cn1x[45:41]};
		else if (EquMid10 && EquLo_2a) ReadData = {8'h00,Epm[8:1]};
		else if (EquMid10 && EquLo_2c) ReadData = {8'h00,Epf10kConf[8:1]};
		else if (EquMid10 && EquLo_2d) ReadData = {8'h00,Epf10kConf[16:9]};
		else if (EquMid10 && EquLo_2e) ReadData = {10'b00,Dedi[6:1]};
		else if (EquMid10 && EquLo_34) ReadData = {8'h00,rIntReg[7:0]};
		else if (EquMid10 && EquLo_35) ReadData = {8'h00,rIntReg[15:8]};
		else if (EquMid10 && EquLo_36) ReadData = {8'h00,rIntReg[23:16]};
		else if (EquMid10 && EquLo_37) ReadData = {8'h00,rIntReg[31:24]};
		else if (EquMid10 && EquLo_38) ReadData = {14'h00,nDreq0,nLinti};
		else 													 ReadData = 16'h00;
	end
end
endfunction
//============================================================================
// assign
//============================================================================
assign Ld = (!nMemOe) ? {16'h00,ReadData(
	nMemOe,
	MemData,
	Cn1x,
	Epm,
	Epf10kConf,
	Dedi,
	rIntReg,
	nDreq0,
	nLinti,
	Equ00000_00FFF,
	Equ10000_1FFFF,
	EquMid10,
	EquLo_14,
	EquLo_15,
	EquLo_16,
	EquLo_17,
	EquLo_18,
	EquLo_19,
	EquLo_2a,
	EquLo_2c,
	EquLo_2d,
	EquLo_2e,
	EquLo_34,
	EquLo_35,
	EquLo_36,
	EquLo_37,
	EquLo_38
)} : 32'hz;
//============================================================================
// assign
//============================================================================
//assign Ioa = 					(rOe[0]) ? rIoa			        : 57'hz;
//assign Iob = 					(rOe[1]) ? rIob			        : 44'hz;
assign Ioc = 					(rOe[2]) ? rIoc								: 31'hz;
assign Iod1_ = 				(rOe[3]) ? rIod1_							: 15'hz;
assign Iod2_ =				(rOe[4]) ? rIod2_							: 32'hz;
assign Cn1_ = 				(rOe[5]) ? rCn1_							: 45'hz;
assign Cn4or5_e = 		(rOe[6]) ? rCn4or5_e					: 45'hz;
assign Epm[8:1] =     (Dummy)  ? 0									: 8'hz;	// Input Only
assign Epm[14:9] =    (rOe[7]) ? rEpm[14:9]					: 6'hz;
assign nWs = 			 		(rOe[8]) ? rEpf10kConf[16]		: 1'bz;
assign nRs = 			 		(rOe[8]) ? rEpf10kConf[15]		: 1'bz;
assign RdynBsy = 	 		(rOe[8]) ? rEpf10kConf[14]		: 1'bz;
assign nCs = 			 		(rOe[8]) ? rEpf10kConf[13]		: 1'bz;
assign Cs = 			 		(rOe[8]) ? rEpf10kConf[12]		: 1'bz;
assign ClkUsr = 	 		(rOe[8]) ? rEpf10kConf[11]		: 1'bz;
assign Data[7:1] = 		(rOe[8]) ? rEpf10kConf[10:4]	: 7'bz;
assign Init_Done = 		(rOe[8]) ? rEpf10kConf[3]			: 1'bz;
assign Dev_Oe = 	 		(rOe[8]) ? rEpf10kConf[2]			: 1'bz;
assign nDev_Clr =	 		(rOe[8]) ? rEpf10kConf[1]			: 1'bz;

endmodule
