//==========================================================================
//	epm7256.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.01 Date 2000 06/08
//
//	tab stops is 2
//============================================================================
module epm7256(
	nNb,
	nLserr,
	Breqo,
	nS0,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	Ld,
	La,
	Data0S,
	Data,
	ClkUsr,
	RdynBsyS,
	CsS,
	nRs,
	nWs,
	Init_DoneS,
	Conf_DoneS,
	nConfigS,
	nStatusS,
	Epm,
	Dev_OeS,
	nDev_ClrS,
	Lclk,
	DedicatedInputs,
	DedicatedClockPins,
	Data0P,
	RdynBsyP,
	CsP,
	Init_DoneP,
	Conf_DoneP,
	nConfigP,
	nStatusP,
	Dev_OeP,
	nDev_ClrP,
	Mclk,
	nOe1,
	nGclr,
	LclkIn,
	Useri,
	nDack0,
	nDreq0,
	nBtermo,
	Usero,
);
//==========================================================================
// PLX 
//==========================================================================
output nNb;				// No Local Bus Initialzation
output nLserr;		// System Error Interrupt Output
output Breqo;			// Bus Request Out
output nS0;				// Address Select 0
output nLreseto;	// Local Bus Reset Out
output nDmapaf;		// Direct Master Programmable Almost Full
output nLlocko;		// Bus Lock
output nWaiti;		// Wait Input
output nBreq;			// Bus Request
output Ldshold;		// Direct Slave HOLD Request
output nEot0;			// End of Transfer
output Lhold;			// Hold Request
output nLholda;		// Hold 
output nBlast;		// Burst Last
output nAds;			// Address Strobe
output nLlock;		// Bus Lock
output nLinti;		// Local Interrupt In
output nLreseti;	// Local Reset Input
output nWaito;		// Wait Out
output nReadyo;		// Ready Out
output nReadyi;		// Ready In
output nBterm;		// Burst Terminate
output nDen;			// Data Enable
output nDt_r;			// Data Transmit/Receive
output nLw_r;			// Write/Read
input Useri;			// User Input
output nDack0;		// DMA Acknowledge Outputs
output nDreq0;		// DMA Request Input
output nBtermo;		// Burst Terminate Output
output Usero;			// User Output

output [16:3] La;	// AddressBus16~3
output [15:0] Ld;	// DataBus15~0
output [3:0] nLbe;// Byte Enables
//==========================================================================
// to EPF10K
//==========================================================================
output Data0S;
output [7:1] Data;
output ClkUsr;
output RdynBsyP;
output RdynBsyS;
output CsP;
output CsS;
output nRs;
output Init_DoneP;
output Init_DoneS;
output nWs;
output Conf_DoneS;
output nConfigS;
output nStatusS;
output [14:1] Epm;
output Dev_OeP;
output Dev_OeS;
output nDev_ClrP;
output nDev_ClrS;
output [3:0] DedicatedInputs;
output DedicatedClockPins;
output Data0P;
output Conf_DoneP;
output nConfigP;
output nStatusP;
//==========================================================================
// Input Pin
//==========================================================================
input Mclk;				//Master Clock 60MHz
input nOe1;
input nGclr;
input LclkIn;			//Lclk Input
//==========================================================================
// Clock Pin
//==========================================================================
output Lclk;
//==========================================================================
// assign
//==========================================================================
wire Dummy = 0;
assign nNb				= (!Dummy) ? 1'bz : 0;
assign nLserr			= (!Dummy) ? 1'bz : 0;
assign Breqo			= (!Dummy) ? 1'bz : 0;
assign nS0				= (!Dummy) ? 1'bz : 0;
assign nLreseto		= (!Dummy) ? 1'bz : 0;
assign nDmapaf		= (!Dummy) ? 1'bz : 0;
assign nLlocko		= (!Dummy) ? 1'bz : 0;
assign nWaiti			= (!Dummy) ? 1'bz : 0;
assign nBreq			= (!Dummy) ? 1'bz : 0;
assign Ldshold		= (!Dummy) ? 1'bz : 0;
assign nEot0			= (!Dummy) ? 1'bz : 0;
assign Lhold			= (!Dummy) ? 1'bz : 0;
assign nLholda		= (!Dummy) ? 1'bz : 0;
assign nBlast			= (!Dummy) ? 1'bz : 0;
assign nAds				= (!Dummy) ? 1'bz : 0;
assign nLlock			= (!Dummy) ? 1'bz : 0;
assign nLinti			= (!Dummy) ? 1'bz : 0;
assign nLreseti		= (!Dummy) ? 1'bz : 0;
assign nWaito			= (!Dummy) ? 1'bz : 0;
assign nReadyo		= (!Dummy) ? 1'bz : 0;
assign nReadyi		= (!Dummy) ? 1'bz : 0;
assign nBterm			= (!Dummy) ? 1'bz : 0;
assign nDen				= (!Dummy) ? 1'bz : 0;
assign nDt_r			= (!Dummy) ? 1'bz : 0;
assign nLw_r			= (!Dummy) ? 1'bz : 0;
assign nDack0			= (!Dummy) ? 1'bz : 0;
assign nDreq0			= (!Dummy) ? 1'bz : 0;
assign nBtermo		= (!Dummy) ? 1'bz : 0;
assign Usero			= (!Dummy) ? 1'bz : 0;
assign La					= (!Dummy) ? 14'bz : 0;
assign Ld					= (!Dummy) ? 16'bz : 0;
assign nLbe				= (!Dummy) ? 4'bz : 0;
assign Epm				= (!Dummy) ? 14'bz : 0;

assign nStatusP		= (!Dummy) ? 1'bz : 0;
assign nStatusS		= (!Dummy) ? 1'bz : 0;
assign nConfigP		= (!Dummy) ? 1'bz : 0;
assign nConfigS		= (!Dummy) ? 1'bz : 0;
assign Conf_DoneP	= (!Dummy) ? 1'bz : 0;
assign Conf_DoneS	= (!Dummy) ? 1'bz : 0;
assign Init_DoneS	= (!Dummy) ? 1'bz : 0; 
assign Init_DoneP = (!Dummy) ? 1'bz : 0;

assign nWs				= (!Useri) ? 0 : 1;
assign nRs				= (!Useri) ? 1 : 0;
assign RdynBsyS 	= (!Dummy) ? 1'bz : 0;
assign RdynBsyP   = (!Dummy) ? 1'bz : 0;
assign CsS				= (!Useri) ? 1 : 0;
assign CsP				= (!Useri) ? 1 : 0;
assign ClkUsr			= (!Useri) ? 0 : 1;
assign Data				= (!Useri) ? 7'h55: 7'haa;
assign Data0P			= (!Dummy) ? 1'bz : 0;
assign Data0S			= (!Dummy) ? 1'bz : 0;
assign Dev_OeS		= (!Useri) ? 0 : 1;
assign Dev_OeP		= (!Useri) ? 0 : 1;
assign nDev_ClrS	= (!Useri) ? 1 : 0;
assign nDev_ClrP	= (!Useri) ? 1 : 0;

assign DedicatedInputs		= (!Useri) ? 4'b1010 : 4'b0101;
assign DedicatedClockPins	= (!Useri) ? 1 : 0;

reg Lclk;
//============================================================================
always @(posedge Mclk) begin
//============================================================================
	Lclk <= ~Lclk;
end
endmodule

