//============================================================================
//	epf5ppap.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.00 Date 2000 4/26
//  Device EPF10K50E
//	tab stops is 2
//============================================================================
module epf5ppap(
	Init_Done,
	nWs,
	nRs,
	nCs,
	Cs,
	RdynBsy,
	ClkUsr,
	Data,
	DedicatedInputPins,
	DedicatedClockPins,
	Dev_Oe,
	nDev_Clr,
	Useri,
	nDack0,
	nDreq0,
	nBtermo,
	Usero,
	nNb,
	nLserr,
	Breqo,
	nS0,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	Epm1_,
	Epm2_,
	Mem,
	Cn1x,
	Cn4or5_e,
	Cn1_,
	Ld,
	La,
//Ioa,
//Iob,
//Ioc,
//Iod1_,
//Iod2_
);
//============================================================================
// PLX 
//============================================================================
output nLholda;
output nLlock;
output nLinti;
output nLreseti;
output nReadyi;
output nBterm;
output nDreq0;
output nS0;
output nNb;
output nWaiti;
output nBreq;
output nEot0;
output Useri;
output nBlast;
output nAds;
output nWaito;
output nReadyo;
output nDen;
output nDt_r;
output nLw_r;
output nDack0;
output nBtermo;
output nLserr;
output Breqo;
output nLreseto;
output nDmapaf;
output nLlocko;
output Ldshold;
output Lhold;
output Usero;
output [31:0] Ld;
output [16:2] La;
output [3:0] nLbe;
//============================================================================
// EPF10K Configuring
//============================================================================
input Init_Done;	// User Mode I/O
input nWs;				// User Mode I/O
input nRs;				// User Mode I/O
input nCs;				// User Mode I/O
input Cs;					// User Mode I/O
input RdynBsy;		// User Mode I/O
input ClkUsr;			// User Mode I/O
input Dev_Oe;			// User Mode I/O
input nDev_Clr;		// User Mode I/O
input [7:1] Data;	// User Mode I/O

input [3:0] DedicatedInputPins;
input [1:0] DedicatedClockPins;
//============================================================================
//
//============================================================================
output [39:1] Mem;
output [45:1]  Cn1_;		// IOE1~45 (Gloup E)
output [8:1]	 Cn1x;		// IOE91~98 (Gloup E)
output [45:1]  Cn4or5_e;// IOE46~90 (Gloup E)
//output [57:1]	 Ioa;			// IOA1~57 (Gloup A)
//output [44:1]	 Iob;			// IOB1~44 (Gloup B)
//output [31:1]  Ioc;			// IOC1~31 (Gloup C)
//output [15:1]  Iod1_;		// IOD1~15 (Gloup D)
//output [84:53] Iod2_;  	// IOD53~84 (Gloup D)
output [8:1]   Epm1_;
output [14:9]  Epm2_;
//============================================================================
// Not Used Pin
//============================================================================
wire Dummy = 0;
assign nLholda		= (!Dummy) ? 1'bz : 0;
assign nLlock			= (!Dummy) ? 1'bz : 0;
assign nLinti			= (!Dummy) ? 1'bz : 0;
assign nLreseti		= (!Dummy) ? 1'bz : 0;
assign nReadyi		= (!Dummy) ? 1'bz : 0;
assign nBterm			= (!Dummy) ? 1'bz : 0;
assign nDreq0			= (!Dummy) ? 1'bz : 0;
assign nS0				= (!Dummy) ? 1'bz : 0;
assign nNb				= (!Dummy) ? 1'bz : 0;
assign nWaiti			= (!Dummy) ? 1'bz : 0;
assign nBreq			= (!Dummy) ? 1'bz : 0;
assign nEot0			= (!Dummy) ? 1'bz : 0;
assign Useri			= (!Dummy) ? 1'bz : 0;
assign nBlast			= (!Dummy) ? 1'bz : 0;
assign nAds				= (!Dummy) ? 1'bz : 0;
assign nWaito			= (!Dummy) ? 1'bz : 0;
assign nReadyo		= (!Dummy) ? 1'bz : 0;
assign nDen				= (!Dummy) ? 1'bz : 0;
assign nDt_r			= (!Dummy) ? 1'bz : 0;
assign nLw_r			= (!Dummy) ? 1'bz : 0;
assign nDack0			= (!Dummy) ? 1'bz : 0;
assign nBtermo		= (!Dummy) ? 1'bz : 0;
assign nLserr			= (!Dummy) ? 1'bz : 0;
assign Breqo			= (!Dummy) ? 1'bz : 0;
assign nLreseto		= (!Dummy) ? 1'bz : 0;
assign nDmapaf		= (!Dummy) ? 1'bz : 0;
assign nLlocko		= (!Dummy) ? 1'bz : 0;
assign Ldshold		= (!Dummy) ? 1'bz : 0;
assign Lhold			= (!Dummy) ? 1'bz : 0;
assign Usero			= (!Dummy) ? 1'bz : 0;
assign Ld					= (!Dummy) ? 32'bz : 0;
assign La 				= (!Dummy) ? 15'bz : 0;
assign nLbe 			= (!Dummy) ? 4'bz : 0;
//============================================================================
// assign EPF10K
//============================================================================
wire [6:1] Dedi = {DedicatedInputPins,DedicatedClockPins};
wire [16:1] Epf10kConf = {nWs,nRs,RdynBsy,nCs,Cs,ClkUsr,Data[7:1],Init_Done,Dev_Oe,nDev_Clr};
//============================================================================
// assign
//============================================================================
assign Mem		= (!Dummy) ? 39'bz : 39'b0;
assign Epm2_	= (!Dummy) ? 6'bz : 6'b0;
//assign Ioa		= (!Dummy) ? 57'bz : 57'b0;
//assign Iob		= (!Dummy) ? 44'bz : 44'b0;
//assign Ioc		= (!Dummy) ? 31'bz : 31'b0;
//assign Iod1_	= (!Dummy) ? 15'bz : 15'b0;
//assign Iod2_	= (!Dummy) ? 31'bz : 31'b0;
assign Cn1_		= (!Dummy) ? 45'bz : 45'b0;
assign Cn1x		= (!Dummy) ? 8'bz : 8'b0;
assign Cn4or5_e		= (!Dummy) ? 45'bz : 45'b0;

assign Epm1_[8:1] = 8'haa;

endmodule

