//==========================================================================
//	epm7256p.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.00 Date 2000/06/08
//
//	tab stops is 2
//============================================================================
module epm7256p(
	nNb,
	nLserr,
	Breqo,
	nS0,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	Ld,
	La,
	Data0S,
	Data,
	Data7,
	ClkUsr,
	RdynBsyS,
	CsS,
	nRs,
	nWs,
	Init_DoneS,
	Conf_DoneS,
	nConfigS,
	nStatusS,
	Epm,
	Dev_OeS,
	nDev_ClrS,
	Lclk,
	DedicatedInputs,
	DedicatedClockPins,
	Data0P,
	RdynBsyP,
	CsP,
	Init_DoneP,
	Conf_DoneP,
	nConfigP,
	nStatusP,
	Dev_OeP,
	nDev_ClrP,
	Mclk,
	nOe1,
	nGclr,
	LclkIn,
	Useri,
	nDack0,
	nDreq0,
	nBtermo,
	Usero
);
//==========================================================================
// PLX 
//==========================================================================
output nNb;				// No Local Bus Initialzation
output nLserr;		// System Error Interrupt Output
output Breqo;			// Bus Request Out
output nS0;				// Address Select 0
input  nLreseto;	// Local Bus Reset Out
output nDmapaf;		// Direct Master Programmable Almost Full
output nLlocko;		// Bus Lock
output nWaiti;		// Wait Input
output nBreq;			// Bus Request
output Ldshold;		// Direct Slave HOLD Request
output nEot0;			// End of Transfer
input  Lhold;			// Hold Request
output nLholda;		// Hold 
input  nBlast;		// Burst Last
input  nAds;			// Address Strobe
output nLlock;		// Bus Lock
output nLinti;		// Local Interrupt In
output nLreseti;	// Local Reset Input
output nWaito;		// Wait Out
output nReadyo;		// Ready Out
output nReadyi;		// Ready In
output nBterm;		// Burst Terminate
output nDen;			// Data Enable
output nDt_r;			// Data Transmit/Receive
input  nLw_r;			// Write/Read
output Useri;			// User Input
output nDack0;		// DMA Acknowledge Outputs
output nDreq0;		// DMA Request Input
output nBtermo;		// Burst Terminate Output
output Usero;			// User Output

input  [16:3] La;	// AddressBus16~3
inout  [15:0] Ld;	// DataBus15~0
input  [3:0] nLbe;// Byte Enables
//==========================================================================
// to EPF10K
//==========================================================================
output Data0S;
output [6:1] Data;
inout  Data7;
output ClkUsr;
input  RdynBsyP;
input  RdynBsyS;
output CsP;
output CsS;
input  nRs;
output Init_DoneP;
output Init_DoneS;
output nWs;
input  Conf_DoneP;
input  Conf_DoneS;
output nConfigS;
input  nStatusS;
input  nStatusP;
input  [14:1] Epm;
output Dev_OeP;
output Dev_OeS;
output nDev_ClrP;
output nDev_ClrS;
output [3:0] DedicatedInputs;
output DedicatedClockPins;
output Data0P;
output nConfigP;
//==========================================================================
// Input Pin
//==========================================================================
input Mclk;				//Master Clock 60MHz
input nOe1;
input nGclr;
input LclkIn;			//Lclk Input
//==========================================================================
// Clock Pin
//==========================================================================
output Lclk;

reg Lclk;
//============================================================================
always @(posedge Mclk) begin
//============================================================================
	Lclk <= ~Lclk;
end
//==========================================================================
// assign
//==========================================================================
wire Dummy = 0;
assign nLserr			= (!Dummy) ? 1'bz : 0;
assign Breqo			= (!Dummy) ? 1'bz : 0;
assign nDmapaf		= (!Dummy) ? 1'bz : 0;
assign nLlocko		= (!Dummy) ? 1'bz : 0;
assign Ldshold		= (!Dummy) ? 1'bz : 0;
assign nWaito			= (!Dummy) ? 1'bz : 0;
assign nReadyo		= (!Dummy) ? 1'bz : 0;
assign nDen				= (!Dummy) ? 1'bz : 0;
assign nDt_r			= (!Dummy) ? 1'bz : 0;
assign Useri			= (!Dummy) ? 1'bz : 0;
assign nDack0			= (!Dummy) ? 1'bz : 0;
assign nBtermo		= (!Dummy) ? 1'bz : 0;
assign Usero			= (!Dummy) ? 1'bz : 0;
assign Init_DoneS	= (!Dummy) ? 1'bz : 0; 
assign Init_DoneP = (!Dummy) ? 1'bz : 0;
assign ClkUsr			= 1;
assign Dev_OeS		= 1;
assign Dev_OeP		= 1;
assign nDev_ClrS	= 1;
assign nDev_ClrP	= 1;

assign DedicatedInputs		= 4'b1111;
assign DedicatedClockPins	= 1;
//============================================================================
// assign
//============================================================================
assign nLlock = 1;
assign nLinti = 1;
assign nLreseti = 1;
assign nBterm = 1;
assign nDreq0 = 1;
assign nS0 = 1;
assign nNb = 0;
assign nWaiti = 1;
assign nBreq = 1;
assign nEot0 = 1;
//============================================================================
// declare Direct Slave Single Cycle
//============================================================================
reg [4:0] s;
reg nLholda;
reg nReadyi;
parameter s0 = 5'b00001;
parameter s1 = 5'b00010;
parameter s2 = 5'b00100;
parameter s3 = 5'b01000;
parameter s4 = 5'b10000;
//============================================================================
always @(posedge Lclk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
		s <= s0;
		nReadyi <= 1;
		nLholda <= 1;
	end else begin
		nLholda <= ~Lhold;
		case (s)
		s0: begin nReadyi <= 1; if (!nAds)	 s <= s1;
														else				 s <= s0;	end
		s1:	begin														 s <= s2; end
		s2:	begin	nReadyi <= 0;							 s <= s3; end
		s3:	begin nReadyi <= 1; if (!nBlast) s <= s0;
														else 				 s <= s4;	end
		s4: begin														 s <= s1;	end
		endcase
	end
end
//============================================================================

//============================================================================
reg Data0P;
reg Data0S;
reg [6:1] Data;
reg rData7;
reg nWs;
reg rRs;
reg CsP;
reg CsS;
reg rConfigP;
reg rConfigS;

wire EquMid00 = (La[16:8]==9'h000);
wire EquLo_00 = (La[7:3]==(8'h00>>3));
wire EquLo_08 = (La[7:3]==(8'h08>>3));
wire EquLo_10 = (La[7:3]==(8'h10>>3));

assign nRs = rRs;
//============================================================================
always @(posedge Lclk or negedge nLreseto)
//============================================================================
begin
	if (!nLreseto) begin
		{rConfigP,rConfigS,CsP,CsS,rRs,nWs,Data0P,Data0S,Data,rData7} <= 15'B000011111111111;
	end else begin
		if (((s==s1) || (s==s2)) && nLw_r) begin
			if (EquMid00 && EquLo_00 && (!nLbe[3])) {rConfigP,CsP,rRs,nWs}	<= Ld[11:8]; //hi byte
			if (EquMid00 && EquLo_00 && (!nLbe[0])) {rData7,Data,Data0P}		<= Ld[7:0];  //lo byte
			if (EquMid00 && EquLo_08 && (!nLbe[3])) {rConfigS,CsS,rRs,nWs}	<= Ld[11:8]; //hi byte
			if (EquMid00 && EquLo_08 && (!nLbe[0])) {rData7,Data,Data0S}		<= Ld[7:0];  //lo byte
		end
	end
end
//============================================================================
function [15:0] ReadData;
//============================================================================
input RdynBsyP;
input RdynBsyS;
input Conf_DoneP;
input Conf_DoneS;
input nStatusP;
input nStatusS;
input EquMid00;
input EquLo_00;
input EquLo_08;
input EquLo_10;
input [14:1] Epm;
input Data7;
begin
	if			(EquMid00 && EquLo_00) ReadData = {12'h0,Data7,nStatusP,Conf_DoneP,RdynBsyP};
	else if (EquMid00 && EquLo_08) ReadData = {12'h0,Data7,nStatusS,Conf_DoneS,RdynBsyS};
	else if (EquMid00 && EquLo_10) ReadData = {2'b00,Epm};
	else 													 ReadData = 16'h0;
end
endfunction
//============================================================================
// Data Read
//============================================================================
wire Read = (((s==s2) || (s==s3)) && !nLw_r);
assign Ld = Read ? ReadData(
	RdynBsyP,
	RdynBsyS,
	Conf_DoneP,
	Conf_DoneS,
	nStatusP,
	nStatusS,
	EquMid00,
	EquLo_00,
	EquLo_08,
	EquLo_10,
	Epm,
	Data7
) : 16'hz;
//============================================================================
//
//============================================================================
assign Data7  =  (!nRs) ? 1'bz : rData7;
assign nConfigP = (!rConfigP) ? 1'b0 : 1'bz;
assign nConfigS = (!rConfigS) ? 1'b0 : 1'bz;

endmodule
