//==========================================================================
//	epm7064i.v
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//	V1.00 Date 2000/06/08
//
//	tab stops is 2
//============================================================================
module epm7064j(
	nLholda,
	nBlast,
	nAds,
	nLlock,
	nLinti,
	nLreseti,
	nWaito,
	nReadyo,
	Lclk,
	nReadyi,
	nBterm,
	nDen,
	nLbe,
	nDt_r,
	nLw_r,
	La,
	ReadData,
	WriteData,
	Tdo,
	nGClr7256,
	nOe17256,
	Ld,
	nDack0,
	nDreq0,
	nBtermo,
	nS0,
	nNb,
	Mclk,
	nLserr,
	Breqo,
	LclkIn,
	nLreseto,
	nDmapaf,
	nLlocko,
	nWaiti,
	nBreq,
	Ldshold,
	nEot0,
	Lhold,
);
//============================================================================
//
//============================================================================
output [2:0] WriteData;
output Lclk;			// Local Clock 30MHz
output nGClr7256;
output nOe17256;

output nLholda;		// Hold Acknowledge
input	 nBlast;		// Burst Last
input  nAds;			// Address Strobe
output nLlock;		// Bus Lock
output nLinti;		// Local Interrupt In
output nLreseti;	// Local Reset Input
input  nWaito;		// Wait Out
input  nReadyo;		// Ready Out
output nReadyi;		// Ready In
output nBterm;		// Burst Terminate
input  nDen;			// Data Enable
input  [3:0] nLbe;// Byte Enables
input  nDt_r;			// Data Transmit/Receive
input  nLw_r;			// Write/Read
input  [16:3] La;	// AddressBus16~3
input  ReadData;
input  Tdo;

inout  [7:0] Ld;	// DataBus7~0
input  nDack0;		// DMA Acknowledge output
output nDreq0;		// DMA Request output
input  nBtermo;		// Burst Terminate output
output nS0;				// Address Select 0
output nNb;				// No Local Bus Initialzation
input  nLreseto;	// Local Bus Reset Out
input  nDmapaf;		// Direct Master Programmable Almost Full
input  nLlocko;		// Bus Lock
output nWaiti;		// Wait Input
output nBreq;			// Bus Request
input  Ldshold;		// Direct Slave HOLD Request
output nEot0;			// End of Transfer
input  Lhold;			// Hold Request
input  nLserr;		// System Error Interrupt Output
input  Breqo;			// Bus Request Out
input  LclkIn;		// Lclk Input

input  Mclk;			// Master Clock 60MHz
//============================================================================
//
//============================================================================
assign nOe17256 = 1;
assign nGClr7256 = 1;

reg Lclk;
//============================================================================
always @(posedge Mclk) begin
//============================================================================
	Lclk <= ~Lclk;
end
//============================================================================
// assign
//============================================================================
assign nLlock = 1;
assign nLinti = 1;
assign nLreseti = 1;
assign nBterm = 1;
assign nDreq0 = 1;
assign nS0 = 1;
assign nNb = 0;
assign nWaiti = 1;
assign nBreq = 1;
assign nEot0 = 1;
//============================================================================
// declare Direct Slave Single Cycle
//============================================================================
reg [4:0] s;
reg nLholda;
reg nReadyi;
parameter s0 = 5'b00001;
parameter s1 = 5'b00010;
parameter s2 = 5'b00100;
parameter s3 = 5'b01000;
parameter s4 = 5'b10000;
//============================================================================
always @(posedge Lclk or negedge nLreseto) begin
//============================================================================
	if (!nLreseto) begin
		s <= s0;
		nReadyi <= 1;
		nLholda <= 1;
	end else begin
		nLholda <= ~Lhold;
		case (s)
		s0: begin nReadyi <= 1; if (!nAds)	 s <= s1;
														else				 s <= s0;	end
		s1:	begin														 s <= s2; end
		s2:	begin	nReadyi <= 0;							 s <= s3; end
		s3:	begin nReadyi <= 1; if (!nBlast) s <= s0;
														else 				 s <= s4;	end
		s4: begin														 s <= s1;	end
		endcase
	end
end
//============================================================================

//============================================================================
reg [2:0] WriteData;
//============================================================================
always @(posedge Lclk or negedge nLreseto)
//============================================================================
begin
	if (!nLreseto) begin
		WriteData <= 0;
	end else begin
		if (((s==s1) || (s==s2)) && nLw_r) begin
			WriteData <= {Ld[1],Ld[0],Ld[2]}; // D2..TMS D1..TCK D0..TDI
		end
	end
end
//============================================================================
// Data Read
//============================================================================
wire Read = (((s==s2) || (s==s3)) && !nLw_r);
assign Ld = Read ? {5'h0,Tdo,1'b0,ReadData} : 8'hz; // D2..TDO
endmodule

